## libmpack-lua 1.0.6

=== Makefile ===
# makefile to setup environment for travis and development

# distributors probably want to set this to 'yes' for both make and make install
USE_SYSTEM_LUA ?= no

# Lua-related configuration
MPACK_LUA_VERSION ?= 5.1.5
MPACK_LUA_VERSION_NOPATCH = $(shell echo -n $(MPACK_LUA_VERSION) | sed 's!\([0-9]\.[0-9]\).[0-9]!\1!')
LUA_URL ?= https://lua.org/ftp/lua-$(MPACK_LUA_VERSION).tar.gz
LUAROCKS_URL ?= https://github.com/keplerproject/luarocks/archive/v2.2.0.tar.gz
LUA_TARGET ?= linux
MPACK_VERSION ?= 1.0.5
MPACK_URL ?= https://github.com/tarruda/libmpack/archive/$(MPACK_VERSION).tar.gz
LMPACK_VERSION ?= $(shell cat mpack-*.rockspec | sed -n "s/^local git_tag = '\\([^']\\+\\)'/\\1/p")

# deps location
DEPS_DIR ?= $(shell pwd)/.deps/$(MPACK_LUA_VERSION)
DEPS_PREFIX ?= $(DEPS_DIR)/usr
DEPS_BIN ?= $(DEPS_PREFIX)/bin

# targets
LUA ?= $(DEPS_BIN)/lua
LUAROCKS ?= $(DEPS_BIN)/luarocks
BUSTED ?= $(DEPS_BIN)/busted
ifeq ($(USE_SYSTEM_LUA),no)
MPACK ?= $(DEPS_PREFIX)/lib/lua/$(MPACK_LUA_VERSION_NOPATCH)/mpack.so
else
MPACK ?= mpack.so
endif

# Compilation
CC ?= gcc
PKG_CONFIG ?= pkg-config
CFLAGS ?= -ansi -O0 -g3 -Wall -Wextra -Werror -Wconversion \
	-Wstrict-prototypes -Wno-unused-parameter -pedantic
CFLAGS += -fPIC -DMPACK_DEBUG_REGISTRY_LEAK
ifeq ($(MPACK_LUA_VERSION_NOPATCH),5.3)
# Lua 5.3 has integer type, which is not 64 bits for -ansi since c89 doesn't
# have `long long` type.
CFLAGS += -DLUA_C89_NUMBERS
endif

LUA_INCLUDE := $(shell $(PKG_CONFIG) --cflags lua-$(MPACK_LUA_VERSION_NOPATCH) 2>/dev/null || echo "-I/usr/include/lua$(MPACK_LUA_VERSION_NOPATCH)")
LUA_LIB := $(shell $(PKG_CONFIG) --libs lua-$(MPACK_LUA_VERSION_NOPATCH) 2>/dev/null || echo "-llua$(MPACK_LUA_VERSION_NOPATCH)")
INCLUDES = $(LUA_INCLUDE)
LIBS = $(LUA_LIB)

LUA_CMOD_INSTALLDIR := $(shell $(PKG_CONFIG) --variable=INSTALL_CMOD lua-$(MPACK_LUA_VERSION_NOPATCH) 2>/dev/null || echo "/usr/lib/lua/$(MPACK_LUA_VERSION_NOPATCH)")


# Misc
# Options used by the 'valgrind' target, which runs the tests under valgrind
VALGRIND_OPTS ?= --error-exitcode=1 --log-file=valgrind.log --leak-check=yes \
	--track-origins=yes
# Command that will download a file and pipe it's contents to stdout
FETCH ?= curl -L -o -
# Command that will gunzip/untar a file from stdin to the current directory,
# stripping one directory component
UNTGZ ?= tar xfz - --strip-components=1


all: $(MPACK)

mpack-src:
	dir="mpack-src"; \
	mkdir -p $$dir && cd $$dir && \
	$(FETCH) $(MPACK_URL) | $(UNTGZ)

release: mpack-src
	rm -f libmpack-lua-$(LMPACK_VERSION).tar.gz
	tar cvfz libmpack-lua-$(LMPACK_VERSION).tar.gz \
		--transform 's,^,libmpack-lua-$(LMPACK_VERSION)/,' \
		mpack-*.rockspec lmpack.c mpack-src/src

clean:
	rm -rf mpack-src *.tar.gz *.src.rock *.so *.o

depsclean:
	rm -rf $(DEPS_DIR)

test: $(BUSTED) $(MPACK)
	$(BUSTED) -o gtest test.lua

valgrind: $(BUSTED) $(MPACK)
	eval $$($(LUAROCKS) path); \
	valgrind $(VALGRIND_OPTS) $(LUA) \
		$(DEPS_PREFIX)/lib/luarocks/rocks/busted/2.0.rc12-1/bin/busted test.lua

ci-test: valgrind
	$(LUA) leak_test.lua

gdb: $(BUSTED) $(MPACK)
	eval $$($(LUAROCKS) path); \
	gdb -x .gdb --args $(LUA) \
		$(DEPS_PREFIX)/lib/luarocks/rocks/busted/2.0.rc12-1/bin/busted test.lua

ifeq ($(USE_SYSTEM_LUA),no)
$(MPACK): $(LUAROCKS) mpack-src lmpack.c
	$(LUAROCKS) make CFLAGS='$(CFLAGS)'
else
$(MPACK): mpack-src lmpack.c
	$(CC) -shared $(CFLAGS) $(INCLUDES) $(LDFLAGS) $^ -o $@ $(LIBS)
endif

$(BUSTED): $(LUAROCKS)
	$(LUAROCKS) install penlight 1.3.2-2
	$(LUAROCKS) install lua-term 0.7-1
	$(LUAROCKS) install dkjson 2.5-2
	$(LUAROCKS) install lua_cliargs 3.0-1
	$(LUAROCKS) install say 1.3-1
	$(LUAROCKS) install luafilesystem 1.6.3-2
	$(LUAROCKS) install luassert 1.7.10-0
	$(LUAROCKS) install mediator_lua 1.1.2-0
	$(LUAROCKS) install luasystem 0.2.0-0
	$(LUAROCKS) install busted 2.0.rc12-1
	$(LUAROCKS) install inspect  # helpful for debugging

$(LUAROCKS): $(LUA)
	dir="$(DEPS_DIR)/src/luarocks"; \
	mkdir -p $$dir && cd $$dir && \
	$(FETCH) $(LUAROCKS_URL) | $(UNTGZ) && \
	./configure --prefix=$(DEPS_PREFIX) --force-config \
		--with-lua=$(DEPS_PREFIX) && make bootstrap

$(LUA):
	dir="$(DEPS_DIR)/src/lua"; \
	mkdir -p $$dir && cd $$dir && \
	$(FETCH) $(LUA_URL) | $(UNTGZ) && \
	sed -i -e '/^CFLAGS/s/-O2/-g3/' src/Makefile && \
	make $(LUA_TARGET) install INSTALL_TOP=$(DEPS_PREFIX)

install: $(MPACK)
ifeq ($(USE_SYSTEM_LUA),no)
	@:
else
	mkdir -p "$(DESTDIR)$(LUA_CMOD_INSTALLDIR)"
	install -Dm755 $< "$(DESTDIR)$(LUA_CMOD_INSTALLDIR)/$<"
endif

.PHONY: all clean depsclean install test gdb valgrind ci-test release

=== debian/changelog ===
libmpack-lua (1.0.6-1) unstable; urgency=medium

  * Initial release after being split out from src:libmpack.
  * Cherry-pick upstream patches to allow using system libs
    + Fix builds using gcc7 and/or system lua
    + Allow linking against system libmpack
  * Remove -pie from DEB_BUILD_MAINT_OPTIONS, due to the new semantics.
  * debian/rules: Make upstream buildsystem link against system libmpack

 -- James McCoy <jamessan@debian.org>  Mon, 24 Jul 2017 23:45:39 -0400

=== debian/control ===
Source: libmpack-lua
Section: interpreters
Priority: extra
Maintainer: James McCoy <jamessan@debian.org>
Build-Depends: debhelper (>= 10),
               dh-lua,
               libmpack-dev,
Standards-Version: 3.9.8
Homepage: https://github.com/libmpack/libmpack-lua/
Vcs-Git: https://anonscm.debian.org/git/collab-maint/libmpack-lua.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/libmpack-lua.git

Package: lua-mpack
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: ${lua:Provides}
XB-Lua-Versions: ${lua:Versions}
Description: libmpack binding for the Lua language
 libmpack is a small binary serialization/RPC library that implements both the
 msgpack and msgpack-rpc specifications.
 .
 This package provides the Lua bindings based on libmpack.

## libmpack-lua 1.0.7

=== Makefile ===
--- 
+++ 
@@ -2,28 +2,36 @@
 
 # distributors probably want to set this to 'yes' for both make and make install
 USE_SYSTEM_LUA ?= no
+USE_SYSTEM_MPACK ?= no
+ifneq ($(USE_SYSTEM_MPACK),no)
+# Can't use luarocks to build if linking against system libmpack because
+# apparently luarocks doesn't let you specify extra linker flags from the
+# command line
+USE_SYSTEM_LUA := 1
+endif
 
 # Lua-related configuration
 MPACK_LUA_VERSION ?= 5.1.5
-MPACK_LUA_VERSION_NOPATCH = $(shell echo -n $(MPACK_LUA_VERSION) | sed 's!\([0-9]\.[0-9]\).[0-9]!\1!')
+MPACK_LUA_VERSION_NOPATCH = $(basename $(MPACK_LUA_VERSION))
 LUA_URL ?= https://lua.org/ftp/lua-$(MPACK_LUA_VERSION).tar.gz
 LUAROCKS_URL ?= https://github.com/keplerproject/luarocks/archive/v2.2.0.tar.gz
 LUA_TARGET ?= linux
 MPACK_VERSION ?= 1.0.5
 MPACK_URL ?= https://github.com/tarruda/libmpack/archive/$(MPACK_VERSION).tar.gz
-LMPACK_VERSION ?= $(shell cat mpack-*.rockspec | sed -n "s/^local git_tag = '\\([^']\\+\\)'/\\1/p")
+LMPACK_VERSION != sed "/^local git_tag =/!d;s/[^']*'//;s/'\$$//;q" mpack-*.rockspec
 
 # deps location
-DEPS_DIR ?= $(shell pwd)/.deps/$(MPACK_LUA_VERSION)
+DEPS_DIR ?= $(CURDIR)/.deps/$(MPACK_LUA_VERSION)
 DEPS_PREFIX ?= $(DEPS_DIR)/usr
 DEPS_BIN ?= $(DEPS_PREFIX)/bin
+DEPS_CMOD ?= $(DEPS_PREFIX)/lib/lua/$(MPACK_LUA_VERSION_NOPATCH)
 
 # targets
 LUA ?= $(DEPS_BIN)/lua
 LUAROCKS ?= $(DEPS_BIN)/luarocks
 BUSTED ?= $(DEPS_BIN)/busted
 ifeq ($(USE_SYSTEM_LUA),no)
-MPACK ?= $(DEPS_PREFIX)/lib/lua/$(MPACK_LUA_VERSION_NOPATCH)/mpack.so
+MPACK ?= $(DEPS_CMOD)/mpack.so
 else
 MPACK ?= mpack.so
 endif
@@ -40,13 +48,20 @@
 CFLAGS += -DLUA_C89_NUMBERS
 endif
 
-LUA_INCLUDE := $(shell $(PKG_CONFIG) --cflags lua-$(MPACK_LUA_VERSION_NOPATCH) 2>/dev/null || echo "-I/usr/include/lua$(MPACK_LUA_VERSION_NOPATCH)")
-LUA_LIB := $(shell $(PKG_CONFIG) --libs lua-$(MPACK_LUA_VERSION_NOPATCH) 2>/dev/null || echo "-llua$(MPACK_LUA_VERSION_NOPATCH)")
+LUA_IMPL ?= lua-$(MPACK_LUA_VERSION_NOPATCH)
+LUA_INCLUDE ?= $(shell $(PKG_CONFIG) --cflags $(LUA_IMPL) 2>/dev/null || echo "-I/usr/include/lua$(MPACK_LUA_VERSION_NOPATCH)")
 INCLUDES = $(LUA_INCLUDE)
-LIBS = $(LUA_LIB)
+LIBS =
 
-LUA_CMOD_INSTALLDIR := $(shell $(PKG_CONFIG) --variable=INSTALL_CMOD lua-$(MPACK_LUA_VERSION_NOPATCH) 2>/dev/null || echo "/usr/lib/lua/$(MPACK_LUA_VERSION_NOPATCH)")
+ifeq ($(USE_SYSTEM_MPACK),no)
+MPACK_SRC = mpack-src
+else
+MPACK_SRC =
+LIBS += $(shell $(PKG_CONFIG) --libs mpack 2>/dev/null || echo "-lmpack")
+CFLAGS += -DMPACK_USE_SYSTEM $(shell $(PKG_CONFIG) --cflags mpack 2> /dev/null)
+endif
 
+LUA_CMOD_INSTALLDIR ?= $(shell $(PKG_CONFIG) --variable=INSTALL_CMOD $(LUA_IMPL) 2>/dev/null || echo "/usr/lib/lua/$(MPACK_LUA_VERSION_NOPATCH)")
 
 # Misc
 # Options used by the 'valgrind' target, which runs the tests under valgrind
@@ -94,13 +109,11 @@
 	gdb -x .gdb --args $(LUA) \
 		$(DEPS_PREFIX)/lib/luarocks/rocks/busted/2.0.rc12-1/bin/busted test.lua
 
-ifeq ($(USE_SYSTEM_LUA),no)
-$(MPACK): $(LUAROCKS) mpack-src lmpack.c
-	$(LUAROCKS) make CFLAGS='$(CFLAGS)'
-else
-$(MPACK): mpack-src lmpack.c
-	$(CC) -shared $(CFLAGS) $(INCLUDES) $(LDFLAGS) $^ -o $@ $(LIBS)
-endif
+$(DEPS_CMOD)/mpack.so: $(LUAROCKS) $(MPACK_SRC) lmpack.c
+	$(LUAROCKS) make CFLAGS='$(CFLAGS)' $(LUAROCKS_LDFLAGS)
+
+mpack.so: lmpack.c $(MPACK_SRC)
+	$(CC) -shared $(CFLAGS) $(INCLUDES) $(LDFLAGS) $< -o $@ $(LIBS)
 
 $(BUSTED): $(LUAROCKS)
 	$(LUAROCKS) install penlight 1.3.2-2

=== debian/changelog ===
libmpack-lua (1.0.7-2) unstable; urgency=medium

  * control: Change Vcs-* to salsa.debian.org
  * Bump debhelper compat to 11
  * copyright: Use https URL for copyright Format
  * Declare compliance with Policy 4.1.3

 -- James McCoy <jamessan@debian.org>  Tue, 13 Mar 2018 22:58:16 -0400

libmpack-lua (1.0.7-1) unstable; urgency=medium

  * New upstream release
  * Adjust defines specified in CLIB_CFLAGS according to upstream build
    changes.
  * Change Priority to optional
  * Add Lintian override for package-name-doesnt-match-sonames
  * Declare compliance with Policy 4.1.2

 -- James McCoy <jamessan@debian.org>  Fri, 15 Dec 2017 08:58:53 -0500

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: libmpack-lua
 Section: interpreters
-Priority: extra
+Priority: optional
 Maintainer: James McCoy <jamessan@debian.org>
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 11),
                dh-lua,
                libmpack-dev,
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
 Homepage: https://github.com/libmpack/libmpack-lua/
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/libmpack-lua.git
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/libmpack-lua.git
+Vcs-Git: https://salsa.debian.org/jamessan/libmpack-lua.git
+Vcs-Browser: https://salsa.debian.org/jamessan/libmpack-lua
 
 Package: lua-mpack
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk

export CFLAGS CPPFLAGS LDFLAGS

%:
	dh $@ --with lua --buildsystem=lua

## libmpack-lua 1.0.10

=== debian/changelog ===
libmpack-lua (1.0.10-1) experimental; urgency=medium

  * New upstream release
  * Add Lua 5.4 support
  * Run upstream test suite during build
  * Switch to debhelper-compat and bump to compat 13
  * Declare *.la files as intentionally not installed
  * Add lua-mpack-dev package
  * Declare Rules-Requires-Root: no
  * Declare compliance with Policy 4.6.2
  * Add mpack to pkgconfig Requires

 -- James McCoy <jamessan@debian.org>  Sun, 20 Aug 2023 12:02:36 -0400

=== debian/control ===
Source: libmpack-lua
Section: interpreters
Priority: optional
Maintainer: James McCoy <jamessan@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-lua,
 libmpack-dev,
 lua-busted <!nocheck>,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://github.com/libmpack/libmpack-lua/
Vcs-Git: https://salsa.debian.org/jamessan/libmpack-lua.git
Vcs-Browser: https://salsa.debian.org/jamessan/libmpack-lua

Package: lua-mpack
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 ${lua:Provides},
XB-Lua-Versions: ${lua:Versions}
Description: libmpack binding for the Lua language
 libmpack is a small binary serialization/RPC library that implements both the
 msgpack and msgpack-rpc specifications.
 .
 This package provides the Lua bindings based on libmpack.

Package: lua-mpack-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libmpack-dev,
 lua-mpack (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 ${lua:Provides},
XB-Lua-Versions: ${lua:Versions}
Description: libmpack binding for the Lua language (development files)
 This package contains the static library and headers for lua-mpack.

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,7 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+export DH_LUA_OPTS="skip-test-app-dynamic skip-test-app-static"
 
 include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/buildflags.mk

## libmpack-lua 1.0.11

=== Makefile ===
--- 
+++ 
@@ -17,7 +17,7 @@
 LUAROCKS_URL ?= https://github.com/keplerproject/luarocks/archive/v2.2.0.tar.gz
 LUA_TARGET ?= linux
 MPACK_VERSION ?= 1.0.5
-MPACK_URL ?= https://github.com/tarruda/libmpack/archive/$(MPACK_VERSION).tar.gz
+MPACK_URL ?= https://github.com/libmpack/libmpack/archive/$(MPACK_VERSION).tar.gz
 LMPACK_VERSION != sed "/^local git_tag =/!d;s/[^']*'//;s/'\$$//;q" mpack-*.rockspec
 
 # deps location
@@ -41,7 +41,7 @@
 PKG_CONFIG ?= pkg-config
 CFLAGS ?= -ansi -O0 -g3 -Wall -Wextra -Werror -Wconversion \
 	-Wstrict-prototypes -Wno-unused-parameter -pedantic
-CFLAGS += -fPIC -DMPACK_DEBUG_REGISTRY_LEAK
+CFLAGS += -fPIC -std=c99 -DMPACK_DEBUG_REGISTRY_LEAK
 ifeq ($(MPACK_LUA_VERSION_NOPATCH),5.3)
 # Lua 5.3 has integer type, which is not 64 bits for -ansi since c89 doesn't
 # have `long long` type.

=== debian/changelog ===
libmpack-lua (1.0.11-0deepin) unsatble; urgency=medium

  * New upstream release

 -- xiangzelong <xiangzelong@deepin.org>  Tue, 10 Oct 2023 15:29:52 +0800

## libmpack-lua 1.0.12

=== debian/changelog ===
libmpack-lua (1.0.12-0deepin1) unstable; urgency=medium

  *  New upstaream release.

 -- xiangzelong <xiangzelong@deepin.org>  Tue, 07 Jan 2025 10:36:34 +0800
